// Code generated by ent, DO NOT EDIT.

package hibp

import (
	"time"

	"entgo.io/ent/dialect/sql"
	"git.dotya.ml/mirre-mt/pcmt/ent/predicate"
	"github.com/google/uuid"
)

// ID filters vertices based on their ID field.
func ID(id uuid.UUID) predicate.HIBP {
	return predicate.HIBP(sql.FieldEQ(FieldID, id))
}

// IDEQ applies the EQ predicate on the ID field.
func IDEQ(id uuid.UUID) predicate.HIBP {
	return predicate.HIBP(sql.FieldEQ(FieldID, id))
}

// IDNEQ applies the NEQ predicate on the ID field.
func IDNEQ(id uuid.UUID) predicate.HIBP {
	return predicate.HIBP(sql.FieldNEQ(FieldID, id))
}

// IDIn applies the In predicate on the ID field.
func IDIn(ids ...uuid.UUID) predicate.HIBP {
	return predicate.HIBP(sql.FieldIn(FieldID, ids...))
}

// IDNotIn applies the NotIn predicate on the ID field.
func IDNotIn(ids ...uuid.UUID) predicate.HIBP {
	return predicate.HIBP(sql.FieldNotIn(FieldID, ids...))
}

// IDGT applies the GT predicate on the ID field.
func IDGT(id uuid.UUID) predicate.HIBP {
	return predicate.HIBP(sql.FieldGT(FieldID, id))
}

// IDGTE applies the GTE predicate on the ID field.
func IDGTE(id uuid.UUID) predicate.HIBP {
	return predicate.HIBP(sql.FieldGTE(FieldID, id))
}

// IDLT applies the LT predicate on the ID field.
func IDLT(id uuid.UUID) predicate.HIBP {
	return predicate.HIBP(sql.FieldLT(FieldID, id))
}

// IDLTE applies the LTE predicate on the ID field.
func IDLTE(id uuid.UUID) predicate.HIBP {
	return predicate.HIBP(sql.FieldLTE(FieldID, id))
}

// Name applies equality check predicate on the "name" field. It's identical to NameEQ.
func Name(v string) predicate.HIBP {
	return predicate.HIBP(sql.FieldEQ(FieldName, v))
}

// Domain applies equality check predicate on the "domain" field. It's identical to DomainEQ.
func Domain(v string) predicate.HIBP {
	return predicate.HIBP(sql.FieldEQ(FieldDomain, v))
}

// BreachDate applies equality check predicate on the "breach_date" field. It's identical to BreachDateEQ.
func BreachDate(v time.Time) predicate.HIBP {
	return predicate.HIBP(sql.FieldEQ(FieldBreachDate, v))
}

// AddedDate applies equality check predicate on the "added_date" field. It's identical to AddedDateEQ.
func AddedDate(v time.Time) predicate.HIBP {
	return predicate.HIBP(sql.FieldEQ(FieldAddedDate, v))
}

// ModifiedDate applies equality check predicate on the "modified_date" field. It's identical to ModifiedDateEQ.
func ModifiedDate(v time.Time) predicate.HIBP {
	return predicate.HIBP(sql.FieldEQ(FieldModifiedDate, v))
}

// PwnCount applies equality check predicate on the "pwn_count" field. It's identical to PwnCountEQ.
func PwnCount(v int) predicate.HIBP {
	return predicate.HIBP(sql.FieldEQ(FieldPwnCount, v))
}

// Description applies equality check predicate on the "description" field. It's identical to DescriptionEQ.
func Description(v string) predicate.HIBP {
	return predicate.HIBP(sql.FieldEQ(FieldDescription, v))
}

// IsVerified applies equality check predicate on the "is_verified" field. It's identical to IsVerifiedEQ.
func IsVerified(v bool) predicate.HIBP {
	return predicate.HIBP(sql.FieldEQ(FieldIsVerified, v))
}

// IsFabricated applies equality check predicate on the "is_fabricated" field. It's identical to IsFabricatedEQ.
func IsFabricated(v bool) predicate.HIBP {
	return predicate.HIBP(sql.FieldEQ(FieldIsFabricated, v))
}

// IsSensitive applies equality check predicate on the "is_sensitive" field. It's identical to IsSensitiveEQ.
func IsSensitive(v bool) predicate.HIBP {
	return predicate.HIBP(sql.FieldEQ(FieldIsSensitive, v))
}

// IsRetired applies equality check predicate on the "is_retired" field. It's identical to IsRetiredEQ.
func IsRetired(v bool) predicate.HIBP {
	return predicate.HIBP(sql.FieldEQ(FieldIsRetired, v))
}

// IsSpamList applies equality check predicate on the "is_spamList" field. It's identical to IsSpamListEQ.
func IsSpamList(v bool) predicate.HIBP {
	return predicate.HIBP(sql.FieldEQ(FieldIsSpamList, v))
}

// IsMalware applies equality check predicate on the "is_malware" field. It's identical to IsMalwareEQ.
func IsMalware(v bool) predicate.HIBP {
	return predicate.HIBP(sql.FieldEQ(FieldIsMalware, v))
}

// Logo applies equality check predicate on the "logo" field. It's identical to LogoEQ.
func Logo(v string) predicate.HIBP {
	return predicate.HIBP(sql.FieldEQ(FieldLogo, v))
}

// NameEQ applies the EQ predicate on the "name" field.
func NameEQ(v string) predicate.HIBP {
	return predicate.HIBP(sql.FieldEQ(FieldName, v))
}

// NameNEQ applies the NEQ predicate on the "name" field.
func NameNEQ(v string) predicate.HIBP {
	return predicate.HIBP(sql.FieldNEQ(FieldName, v))
}

// NameIn applies the In predicate on the "name" field.
func NameIn(vs ...string) predicate.HIBP {
	return predicate.HIBP(sql.FieldIn(FieldName, vs...))
}

// NameNotIn applies the NotIn predicate on the "name" field.
func NameNotIn(vs ...string) predicate.HIBP {
	return predicate.HIBP(sql.FieldNotIn(FieldName, vs...))
}

// NameGT applies the GT predicate on the "name" field.
func NameGT(v string) predicate.HIBP {
	return predicate.HIBP(sql.FieldGT(FieldName, v))
}

// NameGTE applies the GTE predicate on the "name" field.
func NameGTE(v string) predicate.HIBP {
	return predicate.HIBP(sql.FieldGTE(FieldName, v))
}

// NameLT applies the LT predicate on the "name" field.
func NameLT(v string) predicate.HIBP {
	return predicate.HIBP(sql.FieldLT(FieldName, v))
}

// NameLTE applies the LTE predicate on the "name" field.
func NameLTE(v string) predicate.HIBP {
	return predicate.HIBP(sql.FieldLTE(FieldName, v))
}

// NameContains applies the Contains predicate on the "name" field.
func NameContains(v string) predicate.HIBP {
	return predicate.HIBP(sql.FieldContains(FieldName, v))
}

// NameHasPrefix applies the HasPrefix predicate on the "name" field.
func NameHasPrefix(v string) predicate.HIBP {
	return predicate.HIBP(sql.FieldHasPrefix(FieldName, v))
}

// NameHasSuffix applies the HasSuffix predicate on the "name" field.
func NameHasSuffix(v string) predicate.HIBP {
	return predicate.HIBP(sql.FieldHasSuffix(FieldName, v))
}

// NameEqualFold applies the EqualFold predicate on the "name" field.
func NameEqualFold(v string) predicate.HIBP {
	return predicate.HIBP(sql.FieldEqualFold(FieldName, v))
}

// NameContainsFold applies the ContainsFold predicate on the "name" field.
func NameContainsFold(v string) predicate.HIBP {
	return predicate.HIBP(sql.FieldContainsFold(FieldName, v))
}

// DomainEQ applies the EQ predicate on the "domain" field.
func DomainEQ(v string) predicate.HIBP {
	return predicate.HIBP(sql.FieldEQ(FieldDomain, v))
}

// DomainNEQ applies the NEQ predicate on the "domain" field.
func DomainNEQ(v string) predicate.HIBP {
	return predicate.HIBP(sql.FieldNEQ(FieldDomain, v))
}

// DomainIn applies the In predicate on the "domain" field.
func DomainIn(vs ...string) predicate.HIBP {
	return predicate.HIBP(sql.FieldIn(FieldDomain, vs...))
}

// DomainNotIn applies the NotIn predicate on the "domain" field.
func DomainNotIn(vs ...string) predicate.HIBP {
	return predicate.HIBP(sql.FieldNotIn(FieldDomain, vs...))
}

// DomainGT applies the GT predicate on the "domain" field.
func DomainGT(v string) predicate.HIBP {
	return predicate.HIBP(sql.FieldGT(FieldDomain, v))
}

// DomainGTE applies the GTE predicate on the "domain" field.
func DomainGTE(v string) predicate.HIBP {
	return predicate.HIBP(sql.FieldGTE(FieldDomain, v))
}

// DomainLT applies the LT predicate on the "domain" field.
func DomainLT(v string) predicate.HIBP {
	return predicate.HIBP(sql.FieldLT(FieldDomain, v))
}

// DomainLTE applies the LTE predicate on the "domain" field.
func DomainLTE(v string) predicate.HIBP {
	return predicate.HIBP(sql.FieldLTE(FieldDomain, v))
}

// DomainContains applies the Contains predicate on the "domain" field.
func DomainContains(v string) predicate.HIBP {
	return predicate.HIBP(sql.FieldContains(FieldDomain, v))
}

// DomainHasPrefix applies the HasPrefix predicate on the "domain" field.
func DomainHasPrefix(v string) predicate.HIBP {
	return predicate.HIBP(sql.FieldHasPrefix(FieldDomain, v))
}

// DomainHasSuffix applies the HasSuffix predicate on the "domain" field.
func DomainHasSuffix(v string) predicate.HIBP {
	return predicate.HIBP(sql.FieldHasSuffix(FieldDomain, v))
}

// DomainEqualFold applies the EqualFold predicate on the "domain" field.
func DomainEqualFold(v string) predicate.HIBP {
	return predicate.HIBP(sql.FieldEqualFold(FieldDomain, v))
}

// DomainContainsFold applies the ContainsFold predicate on the "domain" field.
func DomainContainsFold(v string) predicate.HIBP {
	return predicate.HIBP(sql.FieldContainsFold(FieldDomain, v))
}

// BreachDateEQ applies the EQ predicate on the "breach_date" field.
func BreachDateEQ(v time.Time) predicate.HIBP {
	return predicate.HIBP(sql.FieldEQ(FieldBreachDate, v))
}

// BreachDateNEQ applies the NEQ predicate on the "breach_date" field.
func BreachDateNEQ(v time.Time) predicate.HIBP {
	return predicate.HIBP(sql.FieldNEQ(FieldBreachDate, v))
}

// BreachDateIn applies the In predicate on the "breach_date" field.
func BreachDateIn(vs ...time.Time) predicate.HIBP {
	return predicate.HIBP(sql.FieldIn(FieldBreachDate, vs...))
}

// BreachDateNotIn applies the NotIn predicate on the "breach_date" field.
func BreachDateNotIn(vs ...time.Time) predicate.HIBP {
	return predicate.HIBP(sql.FieldNotIn(FieldBreachDate, vs...))
}

// BreachDateGT applies the GT predicate on the "breach_date" field.
func BreachDateGT(v time.Time) predicate.HIBP {
	return predicate.HIBP(sql.FieldGT(FieldBreachDate, v))
}

// BreachDateGTE applies the GTE predicate on the "breach_date" field.
func BreachDateGTE(v time.Time) predicate.HIBP {
	return predicate.HIBP(sql.FieldGTE(FieldBreachDate, v))
}

// BreachDateLT applies the LT predicate on the "breach_date" field.
func BreachDateLT(v time.Time) predicate.HIBP {
	return predicate.HIBP(sql.FieldLT(FieldBreachDate, v))
}

// BreachDateLTE applies the LTE predicate on the "breach_date" field.
func BreachDateLTE(v time.Time) predicate.HIBP {
	return predicate.HIBP(sql.FieldLTE(FieldBreachDate, v))
}

// AddedDateEQ applies the EQ predicate on the "added_date" field.
func AddedDateEQ(v time.Time) predicate.HIBP {
	return predicate.HIBP(sql.FieldEQ(FieldAddedDate, v))
}

// AddedDateNEQ applies the NEQ predicate on the "added_date" field.
func AddedDateNEQ(v time.Time) predicate.HIBP {
	return predicate.HIBP(sql.FieldNEQ(FieldAddedDate, v))
}

// AddedDateIn applies the In predicate on the "added_date" field.
func AddedDateIn(vs ...time.Time) predicate.HIBP {
	return predicate.HIBP(sql.FieldIn(FieldAddedDate, vs...))
}

// AddedDateNotIn applies the NotIn predicate on the "added_date" field.
func AddedDateNotIn(vs ...time.Time) predicate.HIBP {
	return predicate.HIBP(sql.FieldNotIn(FieldAddedDate, vs...))
}

// AddedDateGT applies the GT predicate on the "added_date" field.
func AddedDateGT(v time.Time) predicate.HIBP {
	return predicate.HIBP(sql.FieldGT(FieldAddedDate, v))
}

// AddedDateGTE applies the GTE predicate on the "added_date" field.
func AddedDateGTE(v time.Time) predicate.HIBP {
	return predicate.HIBP(sql.FieldGTE(FieldAddedDate, v))
}

// AddedDateLT applies the LT predicate on the "added_date" field.
func AddedDateLT(v time.Time) predicate.HIBP {
	return predicate.HIBP(sql.FieldLT(FieldAddedDate, v))
}

// AddedDateLTE applies the LTE predicate on the "added_date" field.
func AddedDateLTE(v time.Time) predicate.HIBP {
	return predicate.HIBP(sql.FieldLTE(FieldAddedDate, v))
}

// ModifiedDateEQ applies the EQ predicate on the "modified_date" field.
func ModifiedDateEQ(v time.Time) predicate.HIBP {
	return predicate.HIBP(sql.FieldEQ(FieldModifiedDate, v))
}

// ModifiedDateNEQ applies the NEQ predicate on the "modified_date" field.
func ModifiedDateNEQ(v time.Time) predicate.HIBP {
	return predicate.HIBP(sql.FieldNEQ(FieldModifiedDate, v))
}

// ModifiedDateIn applies the In predicate on the "modified_date" field.
func ModifiedDateIn(vs ...time.Time) predicate.HIBP {
	return predicate.HIBP(sql.FieldIn(FieldModifiedDate, vs...))
}

// ModifiedDateNotIn applies the NotIn predicate on the "modified_date" field.
func ModifiedDateNotIn(vs ...time.Time) predicate.HIBP {
	return predicate.HIBP(sql.FieldNotIn(FieldModifiedDate, vs...))
}

// ModifiedDateGT applies the GT predicate on the "modified_date" field.
func ModifiedDateGT(v time.Time) predicate.HIBP {
	return predicate.HIBP(sql.FieldGT(FieldModifiedDate, v))
}

// ModifiedDateGTE applies the GTE predicate on the "modified_date" field.
func ModifiedDateGTE(v time.Time) predicate.HIBP {
	return predicate.HIBP(sql.FieldGTE(FieldModifiedDate, v))
}

// ModifiedDateLT applies the LT predicate on the "modified_date" field.
func ModifiedDateLT(v time.Time) predicate.HIBP {
	return predicate.HIBP(sql.FieldLT(FieldModifiedDate, v))
}

// ModifiedDateLTE applies the LTE predicate on the "modified_date" field.
func ModifiedDateLTE(v time.Time) predicate.HIBP {
	return predicate.HIBP(sql.FieldLTE(FieldModifiedDate, v))
}

// PwnCountEQ applies the EQ predicate on the "pwn_count" field.
func PwnCountEQ(v int) predicate.HIBP {
	return predicate.HIBP(sql.FieldEQ(FieldPwnCount, v))
}

// PwnCountNEQ applies the NEQ predicate on the "pwn_count" field.
func PwnCountNEQ(v int) predicate.HIBP {
	return predicate.HIBP(sql.FieldNEQ(FieldPwnCount, v))
}

// PwnCountIn applies the In predicate on the "pwn_count" field.
func PwnCountIn(vs ...int) predicate.HIBP {
	return predicate.HIBP(sql.FieldIn(FieldPwnCount, vs...))
}

// PwnCountNotIn applies the NotIn predicate on the "pwn_count" field.
func PwnCountNotIn(vs ...int) predicate.HIBP {
	return predicate.HIBP(sql.FieldNotIn(FieldPwnCount, vs...))
}

// PwnCountGT applies the GT predicate on the "pwn_count" field.
func PwnCountGT(v int) predicate.HIBP {
	return predicate.HIBP(sql.FieldGT(FieldPwnCount, v))
}

// PwnCountGTE applies the GTE predicate on the "pwn_count" field.
func PwnCountGTE(v int) predicate.HIBP {
	return predicate.HIBP(sql.FieldGTE(FieldPwnCount, v))
}

// PwnCountLT applies the LT predicate on the "pwn_count" field.
func PwnCountLT(v int) predicate.HIBP {
	return predicate.HIBP(sql.FieldLT(FieldPwnCount, v))
}

// PwnCountLTE applies the LTE predicate on the "pwn_count" field.
func PwnCountLTE(v int) predicate.HIBP {
	return predicate.HIBP(sql.FieldLTE(FieldPwnCount, v))
}

// DescriptionEQ applies the EQ predicate on the "description" field.
func DescriptionEQ(v string) predicate.HIBP {
	return predicate.HIBP(sql.FieldEQ(FieldDescription, v))
}

// DescriptionNEQ applies the NEQ predicate on the "description" field.
func DescriptionNEQ(v string) predicate.HIBP {
	return predicate.HIBP(sql.FieldNEQ(FieldDescription, v))
}

// DescriptionIn applies the In predicate on the "description" field.
func DescriptionIn(vs ...string) predicate.HIBP {
	return predicate.HIBP(sql.FieldIn(FieldDescription, vs...))
}

// DescriptionNotIn applies the NotIn predicate on the "description" field.
func DescriptionNotIn(vs ...string) predicate.HIBP {
	return predicate.HIBP(sql.FieldNotIn(FieldDescription, vs...))
}

// DescriptionGT applies the GT predicate on the "description" field.
func DescriptionGT(v string) predicate.HIBP {
	return predicate.HIBP(sql.FieldGT(FieldDescription, v))
}

// DescriptionGTE applies the GTE predicate on the "description" field.
func DescriptionGTE(v string) predicate.HIBP {
	return predicate.HIBP(sql.FieldGTE(FieldDescription, v))
}

// DescriptionLT applies the LT predicate on the "description" field.
func DescriptionLT(v string) predicate.HIBP {
	return predicate.HIBP(sql.FieldLT(FieldDescription, v))
}

// DescriptionLTE applies the LTE predicate on the "description" field.
func DescriptionLTE(v string) predicate.HIBP {
	return predicate.HIBP(sql.FieldLTE(FieldDescription, v))
}

// DescriptionContains applies the Contains predicate on the "description" field.
func DescriptionContains(v string) predicate.HIBP {
	return predicate.HIBP(sql.FieldContains(FieldDescription, v))
}

// DescriptionHasPrefix applies the HasPrefix predicate on the "description" field.
func DescriptionHasPrefix(v string) predicate.HIBP {
	return predicate.HIBP(sql.FieldHasPrefix(FieldDescription, v))
}

// DescriptionHasSuffix applies the HasSuffix predicate on the "description" field.
func DescriptionHasSuffix(v string) predicate.HIBP {
	return predicate.HIBP(sql.FieldHasSuffix(FieldDescription, v))
}

// DescriptionEqualFold applies the EqualFold predicate on the "description" field.
func DescriptionEqualFold(v string) predicate.HIBP {
	return predicate.HIBP(sql.FieldEqualFold(FieldDescription, v))
}

// DescriptionContainsFold applies the ContainsFold predicate on the "description" field.
func DescriptionContainsFold(v string) predicate.HIBP {
	return predicate.HIBP(sql.FieldContainsFold(FieldDescription, v))
}

// IsVerifiedEQ applies the EQ predicate on the "is_verified" field.
func IsVerifiedEQ(v bool) predicate.HIBP {
	return predicate.HIBP(sql.FieldEQ(FieldIsVerified, v))
}

// IsVerifiedNEQ applies the NEQ predicate on the "is_verified" field.
func IsVerifiedNEQ(v bool) predicate.HIBP {
	return predicate.HIBP(sql.FieldNEQ(FieldIsVerified, v))
}

// IsFabricatedEQ applies the EQ predicate on the "is_fabricated" field.
func IsFabricatedEQ(v bool) predicate.HIBP {
	return predicate.HIBP(sql.FieldEQ(FieldIsFabricated, v))
}

// IsFabricatedNEQ applies the NEQ predicate on the "is_fabricated" field.
func IsFabricatedNEQ(v bool) predicate.HIBP {
	return predicate.HIBP(sql.FieldNEQ(FieldIsFabricated, v))
}

// IsSensitiveEQ applies the EQ predicate on the "is_sensitive" field.
func IsSensitiveEQ(v bool) predicate.HIBP {
	return predicate.HIBP(sql.FieldEQ(FieldIsSensitive, v))
}

// IsSensitiveNEQ applies the NEQ predicate on the "is_sensitive" field.
func IsSensitiveNEQ(v bool) predicate.HIBP {
	return predicate.HIBP(sql.FieldNEQ(FieldIsSensitive, v))
}

// IsRetiredEQ applies the EQ predicate on the "is_retired" field.
func IsRetiredEQ(v bool) predicate.HIBP {
	return predicate.HIBP(sql.FieldEQ(FieldIsRetired, v))
}

// IsRetiredNEQ applies the NEQ predicate on the "is_retired" field.
func IsRetiredNEQ(v bool) predicate.HIBP {
	return predicate.HIBP(sql.FieldNEQ(FieldIsRetired, v))
}

// IsSpamListEQ applies the EQ predicate on the "is_spamList" field.
func IsSpamListEQ(v bool) predicate.HIBP {
	return predicate.HIBP(sql.FieldEQ(FieldIsSpamList, v))
}

// IsSpamListNEQ applies the NEQ predicate on the "is_spamList" field.
func IsSpamListNEQ(v bool) predicate.HIBP {
	return predicate.HIBP(sql.FieldNEQ(FieldIsSpamList, v))
}

// IsMalwareEQ applies the EQ predicate on the "is_malware" field.
func IsMalwareEQ(v bool) predicate.HIBP {
	return predicate.HIBP(sql.FieldEQ(FieldIsMalware, v))
}

// IsMalwareNEQ applies the NEQ predicate on the "is_malware" field.
func IsMalwareNEQ(v bool) predicate.HIBP {
	return predicate.HIBP(sql.FieldNEQ(FieldIsMalware, v))
}

// LogoEQ applies the EQ predicate on the "logo" field.
func LogoEQ(v string) predicate.HIBP {
	return predicate.HIBP(sql.FieldEQ(FieldLogo, v))
}

// LogoNEQ applies the NEQ predicate on the "logo" field.
func LogoNEQ(v string) predicate.HIBP {
	return predicate.HIBP(sql.FieldNEQ(FieldLogo, v))
}

// LogoIn applies the In predicate on the "logo" field.
func LogoIn(vs ...string) predicate.HIBP {
	return predicate.HIBP(sql.FieldIn(FieldLogo, vs...))
}

// LogoNotIn applies the NotIn predicate on the "logo" field.
func LogoNotIn(vs ...string) predicate.HIBP {
	return predicate.HIBP(sql.FieldNotIn(FieldLogo, vs...))
}

// LogoGT applies the GT predicate on the "logo" field.
func LogoGT(v string) predicate.HIBP {
	return predicate.HIBP(sql.FieldGT(FieldLogo, v))
}

// LogoGTE applies the GTE predicate on the "logo" field.
func LogoGTE(v string) predicate.HIBP {
	return predicate.HIBP(sql.FieldGTE(FieldLogo, v))
}

// LogoLT applies the LT predicate on the "logo" field.
func LogoLT(v string) predicate.HIBP {
	return predicate.HIBP(sql.FieldLT(FieldLogo, v))
}

// LogoLTE applies the LTE predicate on the "logo" field.
func LogoLTE(v string) predicate.HIBP {
	return predicate.HIBP(sql.FieldLTE(FieldLogo, v))
}

// LogoContains applies the Contains predicate on the "logo" field.
func LogoContains(v string) predicate.HIBP {
	return predicate.HIBP(sql.FieldContains(FieldLogo, v))
}

// LogoHasPrefix applies the HasPrefix predicate on the "logo" field.
func LogoHasPrefix(v string) predicate.HIBP {
	return predicate.HIBP(sql.FieldHasPrefix(FieldLogo, v))
}

// LogoHasSuffix applies the HasSuffix predicate on the "logo" field.
func LogoHasSuffix(v string) predicate.HIBP {
	return predicate.HIBP(sql.FieldHasSuffix(FieldLogo, v))
}

// LogoEqualFold applies the EqualFold predicate on the "logo" field.
func LogoEqualFold(v string) predicate.HIBP {
	return predicate.HIBP(sql.FieldEqualFold(FieldLogo, v))
}

// LogoContainsFold applies the ContainsFold predicate on the "logo" field.
func LogoContainsFold(v string) predicate.HIBP {
	return predicate.HIBP(sql.FieldContainsFold(FieldLogo, v))
}

// And groups predicates with the AND operator between them.
func And(predicates ...predicate.HIBP) predicate.HIBP {
	return predicate.HIBP(func(s *sql.Selector) {
		s1 := s.Clone().SetP(nil)
		for _, p := range predicates {
			p(s1)
		}
		s.Where(s1.P())
	})
}

// Or groups predicates with the OR operator between them.
func Or(predicates ...predicate.HIBP) predicate.HIBP {
	return predicate.HIBP(func(s *sql.Selector) {
		s1 := s.Clone().SetP(nil)
		for i, p := range predicates {
			if i > 0 {
				s1.Or()
			}
			p(s1)
		}
		s.Where(s1.P())
	})
}

// Not applies the not operator on the given predicate.
func Not(p predicate.HIBP) predicate.HIBP {
	return predicate.HIBP(func(s *sql.Selector) {
		p(s.Not())
	})
}
